// 
//  пример простейшего кода для обработки массива
// 

// прототипы библиотечных функций
#include <stdio.h>
#include <stdlib.h>

// прототипы наших функций
#include "minmax.h"
#include "array.h"



// тест обработки массива

int main(void)
{
   FILE *fin;   // указатель на файл данных
   char filename[256];
   double *array;
   double  amax;
   int size;

   // имя файла с данными
   printf("data file name >");
   if (scanf("%s", filename) != 1) {
      printf("Error reading data filename\n");
      return -1; 
   }   // не самый хороший способ, но пусть пока так

   // доступ к файлу
   fin = fopen(filename, "r");
   if (!fin) {
      printf("Error opening file %s\n", filename);
      return -1; 
   }

   // чтение и создание массива данных
   if (fscanf(fin, "%d", &size) != 1) {
      printf("Cannot read array size from file %s\n", filename);
      return -1; 
   }
   array = ReadArrayNum(fin, size);
   
   // файл прочитали, он больше не нужен
   fclose(fin);

   // тестовая проверка и печать 
   if (array) {
      printf("Array length = %d\n", size);
      PrintArray(stdout, array, size, "\nArray from file");
   } else {
      printf("array processing error\n");
      return -1; 
   }

   // обработка массива 
   amax = Max(array, size);

   // вывод результата
   printf("max = %f\n", amax);

   // освобождение захваченных ресурсов
   free(array);


   // тест с генерацией массива
   size = 20;
   array = GenerateArray(size);
   if (!array) {
      printf("array generation error: size=%d\n", size);
      return -1;
   }
   amax = Max(array, size);
   PrintArray(stdout, array, size, "\nGenerated array");
   printf("max = %f\n", amax);

   // освобождение захваченных ресурсов
   free(array);

   return 0;
}


